import { useLocalStorage } from '../util/PersistentStorage'

const Persistent = (() => {
  const [getEnabled, setEnabled] = useLocalStorage('polling.enabled', true);

  return {
    getEnabled,
    setEnabled
  }
})(); // <<--- execute

export const pollingGetInitialState = () => {
  return {
    enabled: Persistent.getEnabled() === 'true',

    games: false,
    leaderboard: false
  }
};

export function pollingReducer(state, action) {
  switch (action.type) {

    case 'toggleOnOff': return {
      ...state,
      enabled: Persistent.setEnabled(!state.enabled)
    };

    case 'setGames': return {
      ...state,
      games: action.value
    };

    case 'setLeaderboard': return {
      ...state,
      leaderboard: action.value
    };

    default:
      throw Error('Unknown action.type:' + action.type);
  }
}

const Polling = {
  initialState: pollingGetInitialState(), // <<--- execute
  reducer: pollingReducer
}

export default Polling